"""
    Tick History

     <p>FactSet’s Tick History provides cost-effective access to real-time and delayed global exchange data. Proprietary technology normalizes over 200 global exchanges and 19 tick history fields. Asset types integrated include equities, futures, options, fixed income, mutual funds, ETFs, indices, commodities, and FX rates.</p><p>Tick History provides dynamic access to tick data for a specific security intra-day or historically via standard HTTPS protocol. History is available for all quotes and trades for a trailing 6 months or 1-year, respectively. Quotes and trade data for Options is available for 30 days. Tick History data is also available in a separate end-of-day feed.</p>     # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.FactSetIntradayTickHistory.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.FactSetIntradayTickHistory.exceptions import ApiAttributeError



class Fields(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'bid_1': (float,),  # noqa: E501
            'bid_vol_1': (int,),  # noqa: E501
            'bid_exch_1': (str,),  # noqa: E501
            'ask_1': (float,),  # noqa: E501
            'ask_vol_1': (int,),  # noqa: E501
            'ask_exch_1': (str,),  # noqa: E501
            'last_1': (float,),  # noqa: E501
            'last_date_1': (str,),  # noqa: E501
            'last_time_1': (str,),  # noqa: E501
            'last_vol_1': (int,),  # noqa: E501
            'last_exch_1': (str,),  # noqa: E501
            'cum_vol': (int,),  # noqa: E501
            'vwap': (float,),  # noqa: E501
            'open_1': (float,),  # noqa: E501
            'high_1': (float,),  # noqa: E501
            'low_1': (float,),  # noqa: E501
            'trade_condition': (str,),  # noqa: E501
            'gmt_offset': (int,),  # noqa: E501
            'price_currency': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'bid_1': 'BID_1',  # noqa: E501
        'bid_vol_1': 'BID_VOL_1',  # noqa: E501
        'bid_exch_1': 'BID_EXCH_1',  # noqa: E501
        'ask_1': 'ASK_1',  # noqa: E501
        'ask_vol_1': 'ASK_VOL_1',  # noqa: E501
        'ask_exch_1': 'ASK_EXCH_1',  # noqa: E501
        'last_1': 'LAST_1',  # noqa: E501
        'last_date_1': 'LAST_DATE_1',  # noqa: E501
        'last_time_1': 'LAST_TIME_1',  # noqa: E501
        'last_vol_1': 'LAST_VOL_1',  # noqa: E501
        'last_exch_1': 'LAST_EXCH_1',  # noqa: E501
        'cum_vol': 'CUM_VOL',  # noqa: E501
        'vwap': 'VWAP',  # noqa: E501
        'open_1': 'OPEN_1',  # noqa: E501
        'high_1': 'HIGH_1',  # noqa: E501
        'low_1': 'LOW_1',  # noqa: E501
        'trade_condition': 'TRADE_CONDITION',  # noqa: E501
        'gmt_offset': 'GMT_OFFSET',  # noqa: E501
        'price_currency': 'PRICE_CURRENCY',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """Fields - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bid_1 (float): The last bid price or last bid price in an interval. FID # 100. [optional]  # noqa: E501
            bid_vol_1 (int): The volume of the last bid in an interval. FID # 104. [optional]  # noqa: E501
            bid_exch_1 (str): The volume of the last bid or last bid in an interval. FID # 107. Enumeration Table 7. [optional]  # noqa: E501
            ask_1 (float): The last ask price or last ask price in an interval. FID # 200. [optional]  # noqa: E501
            ask_vol_1 (int): The volume of the last ask or last ask in an interval. FID # 204. [optional]  # noqa: E501
            ask_exch_1 (str): The exchange of the last ask or last ask in an interval. FID # 207. Enumeration Table 7.. [optional]  # noqa: E501
            last_1 (float): The last trade price or last trade price in an interval. FID # 300. [optional]  # noqa: E501
            last_date_1 (str): The date of the last trade or last trade in an interval. FID # 301. [optional]  # noqa: E501
            last_time_1 (str): The time of the last trade or last trade in an interval. FID # 302. [optional]  # noqa: E501
            last_vol_1 (int): The trade volume, or the sum of all trade volumes inside a bin. FID # 304. [optional]  # noqa: E501
            last_exch_1 (str): The exchange of the last trade or last trade in an interval. FID # 307. Enumeration Table 7. [optional]  # noqa: E501
            cum_vol (int): The symbol's daily cumulative volume, or the last cumulative volume in an interval. FID # 601. [optional]  # noqa: E501
            vwap (float): The daily volume weighted average price, or the last VWAP in an interval. FID # 603. [optional]  # noqa: E501
            open_1 (float): The first trade of an interval. FID # 710. [optional]  # noqa: E501
            high_1 (float): The highest trade price in an interval. FID # 720. [optional]  # noqa: E501
            low_1 (float): The lowest trade price in an interval. FID # 723. [optional]  # noqa: E501
            trade_condition (str): Trade Condition. FID # 2709. [optional]  # noqa: E501
            gmt_offset (int): GMT Offset in Minutes. FID # 2037. [optional]  # noqa: E501
            price_currency (str): Price Currency Code. FID # 2032. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """Fields - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bid_1 (float): The last bid price or last bid price in an interval. FID # 100. [optional]  # noqa: E501
            bid_vol_1 (int): The volume of the last bid in an interval. FID # 104. [optional]  # noqa: E501
            bid_exch_1 (str): The volume of the last bid or last bid in an interval. FID # 107. Enumeration Table 7. [optional]  # noqa: E501
            ask_1 (float): The last ask price or last ask price in an interval. FID # 200. [optional]  # noqa: E501
            ask_vol_1 (int): The volume of the last ask or last ask in an interval. FID # 204. [optional]  # noqa: E501
            ask_exch_1 (str): The exchange of the last ask or last ask in an interval. FID # 207. Enumeration Table 7.. [optional]  # noqa: E501
            last_1 (float): The last trade price or last trade price in an interval. FID # 300. [optional]  # noqa: E501
            last_date_1 (str): The date of the last trade or last trade in an interval. FID # 301. [optional]  # noqa: E501
            last_time_1 (str): The time of the last trade or last trade in an interval. FID # 302. [optional]  # noqa: E501
            last_vol_1 (int): The trade volume, or the sum of all trade volumes inside a bin. FID # 304. [optional]  # noqa: E501
            last_exch_1 (str): The exchange of the last trade or last trade in an interval. FID # 307. Enumeration Table 7. [optional]  # noqa: E501
            cum_vol (int): The symbol's daily cumulative volume, or the last cumulative volume in an interval. FID # 601. [optional]  # noqa: E501
            vwap (float): The daily volume weighted average price, or the last VWAP in an interval. FID # 603. [optional]  # noqa: E501
            open_1 (float): The first trade of an interval. FID # 710. [optional]  # noqa: E501
            high_1 (float): The highest trade price in an interval. FID # 720. [optional]  # noqa: E501
            low_1 (float): The lowest trade price in an interval. FID # 723. [optional]  # noqa: E501
            trade_condition (str): Trade Condition. FID # 2709. [optional]  # noqa: E501
            gmt_offset (int): GMT Offset in Minutes. FID # 2037. [optional]  # noqa: E501
            price_currency (str): Price Currency Code. FID # 2032. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
